//
//  ViewController.m
//  SQLLiteDemo
//
//  Created by Brian Moakley on 5/21/14.
//  Copyright (c) 2014 Razeware. All rights reserved.
//

#import "ViewController.h"
#import <sqlite3.h>

@interface ViewController ()



@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    NSFileManager * fileManager = [NSFileManager defaultManager];
    NSURL * filePath = [fileManager URLForDirectory:NSDocumentDirectory inDomain:NSUserDomainMask appropriateForURL:nil create:NO error:nil];
    NSString * path = [filePath absoluteString];
    path = [path stringByAppendingPathComponent:@"sampe.sqlite"];
    sqlite3 * db;
    const char * dbPath = [path UTF8String];
    sqlite3_open(dbPath, &db);
    NSLog(@"%s", dbPath);
    
    
    if (sqlite3_open(dbPath, &db) == SQLITE_OK)
    {
        
        char * errMsg;
        const char * sql_stmt = "create table if not exists Tutorials (ID Integer Primary key AutoIncrement, Title Text, Author Text, PublicationDate Date);";

        
        if (sqlite3_exec(db, sql_stmt, NULL, NULL, &errMsg) != SQLITE_OK) {
            NSLog(@"Failed to create table.");
        } else {
            NSLog(@"Created table");
        }

        
        sqlite3_stmt * statment;
        const char * sql = "insert into Tutorials (Title, Author, PublicationDate) values ('Intro to SQLite', 'Ray Wenderlich', '2014-08-10 11:00:00')";
        sqlite3_prepare_v2(db, sql, -1, &statment, NULL);
        if (sqlite3_step(statment) == SQLITE_DONE)
        {
            NSLog(@"Inserted");
        }
        sqlite3_finalize(statment);
        
        sqlite3_stmt * selectStatement;
        const char * select_sql = "select * from Tutorials";
        if (sqlite3_prepare_v2(db, select_sql, -1, &selectStatement, NULL) == SQLITE_OK)
        {
            while (sqlite3_step(selectStatement) == SQLITE_ROW)
            {
                int rowId = sqlite3_column_int(selectStatement, 0);
                char * title = (char *) sqlite3_column_text(selectStatement, 1);
                char * author = (char *)  sqlite3_column_text(selectStatement, 2);
                char * date = (char *) sqlite3_column_text(selectStatement, 3);
                
                NSLog(@"%d %s %s %s", rowId, title, author, date);
                
            }
        }
        
        const char * rmSql = "update Tutorials set Author = 'Brian Moakley' where ID = 0";
        char * errorMessage;
        if (sqlite3_exec(db, rmSql, NULL, NULL, &errorMessage) == SQLITE_DONE) {
            NSLog(@"Created table");
        } else {
            NSLog(@"Failed to create table.");
        }
        
        
        sqlite3_stmt * selectStatement2;
        const char * select_sql2 = "select * from Tutorials";
        if (sqlite3_prepare_v2(db, select_sql2, -1, &selectStatement2, NULL) == SQLITE_OK)
        {
            while (sqlite3_step(selectStatement2) == SQLITE_ROW)
            {
                int rowId = sqlite3_column_int(selectStatement2, 0);
                char * title = (char *) sqlite3_column_text(selectStatement2, 1);
                char * author = (char *)  sqlite3_column_text(selectStatement2, 2);
                char * date = (char *) sqlite3_column_text(selectStatement2, 3);
                
                NSLog(@"%d %s %s %s", rowId, title, author, date);
                
            }
        }
        
        sqlite3_stmt * updateStatement;
        const char * updateSql = "update Tutorials set Author = ?, Title = ? where ID = 1";
        const char * author = "Chris LaPallo";
        const char * tutorial = "Unity 2D";
        sqlite3_prepare(db, updateSql, -1, &updateStatement, 0);
        sqlite3_bind_text(updateStatement, 1, author, -1, SQLITE_TRANSIENT);
        sqlite3_bind_text(updateStatement, 2, tutorial, -1, SQLITE_TRANSIENT);
        

        if (sqlite3_step(updateStatement) == SQLITE_DONE)
        {
            NSLog(@"Updated Unity");
        }
        
    }
    
    
    sqlite3_close(db);

	

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
